REPLY_CODES = {
    '0': 'RPLNONE',
    # INITIAL
    '001': 'RPLWELCOME',  # :WELCOME TO THE INTERNET RELAY NETWORK <NICKNAME>
    '002': 'RPLYOURHOST',  # :YOUR HOST IS <SERVER>, RUNNING VERSION <VER>
    '003': 'RPLCREATED',  # :THIS SERVER WAS CREATED <DATETIME>
    '004': 'RPLMYINFO',  # <SERVER> <VER> <USERMODE> <CHANMODE>
    '005': 'RPLMAP',  # :MAP
    '007': 'RPLENDOFMAP',  # :END OF /MAP
    '375': 'RPLMOTDSTART',  # :- SERVER MESSAGE OF THE DAY
    '372': 'RPLMOTD',  # :- <INFO>
    '377': 'RPLMOTDALT',  # :- <INFO>
    '378': 'RPLMOTDALT2',  # :- <INFO>
    '376': 'RPLMOTDEND',  # :END OF /M'OTD COMMAND.
    '221': 'RPLUMODEIS',  # <MODE>

    # ISON/USERHOST
    '302': 'RPLUSERHOST',  # :USERHOSTS
    '303': 'RPLISON',  # :NICKNAMES

    # AWAY
    '301': 'RPLAWAY',  # <NICK> :AWAY
    '305': 'RPLUNAWAY',  # :YOU ARE NO LONGER MARKED AS BEING AWAY
    '306': 'RPLNOWAWAY',  # :YOU HAVE BEEN MARKED AS BEING AWAY

    # WHOIS/WHOWAS
    '310': 'RPLWHOISHELPER',  # <NICK> :LOOKS VERY HELPFUL
    '311': 'RPLWHOISUSER',  # <NICK> <USERNAME> <ADDRESS> * :<INFO>
    '312': 'RPLWHOISSERVER',  # <NICK> <SERVER> :<INFO>
    '313': 'RPLWHOISOPERATOR',  # <NICK> :IS AN IRC OPERATOR
    '317': 'RPLWHOISIDLE',  # <NICK> <SECONDS> <SIGNON> :<INFO>
    '318': 'RPLENDOFWHOIS',  # <REQUEST> :END OF /WHOIS LIST.
    '319': 'RPLWHOISCHANNELS',  # <NICK> :<CHANNELS>
    '314': 'RPLWHOWASUSER',  # <NICK> <USERNAME> <ADDRESS> * :<INFO>
    '369': 'RPLENDOFWHOWAS',  # <REQUEST> :END OF WHOWAS
    '352': 'RPLWHOREPLY',  # <CHANNEL> <USERNAME> <ADDRESS> <SERVER> <NICK> <FLAGS> :<HOPS> <INFO>
    '315': 'RPLENDOFWHO',  # <REQUEST> :END OF /WHO LIST.
    '307': 'RPLUSERIPS',  # :USERIPS
    '340': 'RPLUSERIP',  # <NICK> :<NICKNAME>=+<USER>@<IP.ADDRESS>

    # LIST
    '321': 'RPLLISTSTART',  # CHANNEL :USERS NAME
    '322': 'RPLLIST',  # <CHANNEL> <USERS> :<TOPIC>
    '323': 'RPLLISTEND',  # :END OF /LIST
    '364': 'RPLLINKS',  # <SERVER> <HUB> :<HOPS> <INFO>
    '365': 'RPLENDOFLINKS',  # <MASK> :END OF /LINKS LIST.

    # POST-CHANNEL JOIN
    '325': 'RPLUNIQOPIS',  #
    '324': 'RPLCHANNELMODEIS',  # <CHANNEL> <MODE>
    '328': 'RPLCHANNELURL',  # <CHANNEL> :URL
    '329': 'RPLCHANNELCREATED',  # <CHANNEL> <TIME>
    '331': 'RPLNOTOPIC',  # <CHANNEL> :NO TOPIC IS SET.
    '332': 'RPLTOPIC',  # <CHANNEL> :<TOPIC>
    '333': 'RPLTOPICSETBY',  # <CHANNEL> <NICKNAME> <TIME>
    '353': 'RPLNAMREPLY',  # = <CHANNEL> :<NAMES>
    '366': 'RPLENDOFNAMES',  # <CHANNEL> :END OF /NAMES LIST.

    # INVITATIONAL
    '341': 'RPLINVITING',  # <NICK> <CHANNEL>
    '342': 'RPLSUMMONING',  #

    # CHANNEL LISTS
    '346': 'RPLINVITELIST',  # <CHANNEL> <INVITE> <NICK> <TIME>
    '357': 'RPLENDOFINVITELIST',  # <CHANNEL> :END OF CHANNEL INVITE LIST
    '348': 'RPLEXCEPTLIST',  # <CHANNEL> <EXCEPTION> <NICK> <TIME>
    '349': 'RPLENDOFEXCEPTLIST',  # <CHANNEL> :END OF CHANNEL EXCEPTION LIST
    '367': 'RPLBANLIST',  # <CHANNEL> <BAN> <NICK> <TIME>
    '368': 'RPLENDOFBANLIST',  # <CHANNEL> :END OF CHANNEL BAN LIST

    # SERVER/MISC
    '351': 'RPLVERSION',  # <VERSION>.<DEBUG> <SERVER> :<INFO>
    '371': 'RPLINFO',  # :<INFO>
    '374': 'RPLENDOFINFO',  # :END OF /INFO LIST.
    '381': 'RPLYOUREOPER',  # :YOU ARE NOW AN IRC OPERATOR
    '382': 'RPLREHASHING',  # <FILE> :REHASHING
    '383': 'RPLYOURESERVICE',  #
    '391': 'RPLTIME',  # <SERVER> :<TIME>
    '392': 'RPLUSERSSTART',  #
    '393': 'RPLUSERS',  #
    '394': 'RPLENDOFUSERS',  #
    '395': 'RPLNOUSERS',  #
    '234': 'RPLSERVLIST',  #
    '235': 'RPLSERVLISTEND',  #
    '256': 'RPLADMINME',  # :ADMINISTRATIVE INFO ABOUT SERVER
    '257': 'RPLADMINLOC1',  # :<INFO>
    '258': 'RPLADMINLOC2',  # :<INFO>
    '259': 'RPLADMINEMAIL',  # :<INFO>
    '263': 'RPLTRYAGAIN',  # :SERVER LOAD IS TEMPORARILY TOO HEAVY. PLEASE WAIT A WHILE AND TRY AGAIN.

    # TRACING
    '200': 'RPLTRACELINK',  #
    '201': 'RPLTRACECONNECTING',  #
    '202': 'RPLTRACEHANDSHAKE',  #
    '203': 'RPLTRACEUNKNOWN',  #
    '204': 'RPLTRACEOPERATOR',  #
    '205': 'RPLTRACEUSER',  #
    '206': 'RPLTRACESERVER',  #
    '207': 'RPLTRACESERVICE',  #
    '208': 'RPLTRACENEWTYPE',  #
    '209': 'RPLTRACECLASS',  #
    '210': 'RPLTRACERECONNECT',  #
    '261': 'RPLTRACELOG',  #
    '262': 'RPLTRACEEND',  #

    # STATS
    '211': 'RPLSTATSLINKINFO',  # <CONNECTION> <SENDQ> <SENTMSG> <SENTBYTE> <RECDMSG> <RECDBYTE> :<OPEN>
    '212': 'RPLSTATSCOMMANDS',  # <COMMAND> <USES> <BYTES>
    '213': 'RPLSTATSCLINE',  # C <ADDRESS> * <SERVER> <PORT> <CLASS>
    '214': 'RPLSTATSNLINE',  # N <ADDRESS> * <SERVER> <PORT> <CLASS>
    '215': 'RPLSTATSILINE',  # I <IPMASK> * <HOSTMASK> <PORT> <CLASS>
    '216': 'RPLSTATSKLINE',  # K <ADDRESS> * <USERNAME> <DETAILS>
    '217': 'RPLSTATSPLINE',  # P <PORT> <??> <??>
    '222': 'RPLSTATSQLINE',  # <MASK> :<COMMENT>
    '223': 'RPLSTATSELINE',  # E <HOSTMASK> * <USERNAME> <??> <??>
    '224': 'RPLSTATSDLINE',  # D <IPMASK> * <USERNAME> <??> <??>
    '241': 'RPLSTATSLLINE',  # L <ADDRESS> * <SERVER> <??> <??>
    '242': 'RPLSTATSULINE',  # :SERVER UP <NUM> DAYS, <TIME>
    '243': 'RPLSTATSOLINE',  # O <MASK> <PASSWORD> <USER> <??> <CLASS>
    '244': 'RPLSTATSHLINE',  # H <ADDRESS> * <SERVER> <??> <??>
    '247': 'RPLSTATSGLINE',  # G <ADDRESS> <TIMESTAMP> :<REASON>
    '248': 'RPLSTATSULINE',  # U <HOST> * <??> <??> <??>
    '249': 'RPLSTATSZLINE',  # :INFO
    '218': 'RPLSTATSYLINE',  # Y <CLASS> <PING> <FREQ> <MAXCONNECT> <SENDQ>
    '219': 'RPLENDOFSTATS',  # <CHAR> :END OF /STATS REPORT

    # GLINE
    '280': 'RPLGLINELIST',  # <ADDRESS> <TIMESTAMP> <REASON>
    '281': 'RPLENDOFGLINELIST',  # :END OF G-LINE LIST

    # SILENCE
    '271': 'RPLSILENCELIST',  # <NICK> <MASK>
    '272': 'RPLENDOFSILENCELIST',  # <NICK> :END OF SILENCE LIST

    # LUSER
    '251': 'RPLLUSERCLIENT',  # :THERE ARE <USER> USERS AND <INVIS> INVISIBLE ON <SERV> SERVERS
    '252': 'RPLLUSEROP',  # <NUM> :OPERATOR(S) ONLINE
    '253': 'RPLLUSERUNKNOWN',  # <NUM> :UNKNOWN CONNECTION(S)
    '254': 'RPLLUSERCHANNELS',  # <NUM> :CHANNELS FORMED
    '255': 'RPLLUSERME',  # :I HAVE <USER> CLIENTS AND <SERV> SERVERS
    '265': 'RPLLUSERLOCALUSER',  # :CURRENT LOCAL USERS: <CURR> MAX: <MAX>
    '266': 'RPLLUSERGLOBALUSER',  # :CURRENT GLOBAL USERS: <CURR> MAX: <MAX>

    # ERRORS
    '401': 'ERRNOSUCHNICK',  # <NICKNAME> :NO SUCH NICK
    '402': 'ERRNOSUCHSERVER',  # <SERVER> :NO SUCH SERVER
    '403': 'ERRNOSUCHCHANNEL',  # <CHANNEL> :NO SUCH CHANNEL
    '404': 'ERRCANNOTSENDTOCHAN',  # <CHANNEL> :CANNOT SEND TO CHANNEL
    '405': 'ERRTOOMANYCHANNELS',  # <CHANNEL> :YOU HAVE JOINED TOO MANY CHANNELS
    '406': 'ERRWASNOSUCHNICK',  # <NICKNAME> :THERE WAS NO SUCH NICKNAME
    '407': 'ERRTOOMANYTARGETS',  # <TARGET> :DUPLICATE RECIPIENTS. NO MESSAGE DELIVERED
    '408': 'ERRNOCOLORS',  # <NICKNAME> #<CHANNEL> :YOU CANNOT USE COLORS ON THIS CHANNEL. NOT SENT: <TEXT>
    '409': 'ERRNOORIGIN',  # :NO ORIGIN SPECIFIED
    '411': 'ERRNORECIPIENT',  # :NO RECIPIENT GIVEN (<COMMAND>)
    '412': 'ERRNOTEXTTOSEND',  # :NO TEXT TO SEND
    '413': 'ERRNOTOPLEVEL',  # <MASK> :NO TOPLEVEL DOMAIN SPECIFIED
    '414': 'ERRWILDTOPLEVEL',  # <MASK> :WILDCARD IN TOPLEVEL DOMAIN
    '415': 'ERRBADMASK',  #
    '416': 'ERRTOOMUCHINFO',  # <COMMAND> :TOO MANY LINES IN THE OUTPUT, RESTRICT YOUR QUERY
    '421': 'ERRUNKNOWNCOMMAND',  # <COMMAND> :UNKNOWN COMMAND
    '422': 'ERRNOMOTD',  # :MOTD FILE IS MISSING
    '423': 'ERRNOADMININFO',  # <SERVER> :NO ADMINISTRATIVE INFO AVAILABLE
    '424': 'ERRFILEERROR',  #
    '431': 'ERRNONICKNAMEGIVEN',  # :NO NICKNAME GIVEN
    '432': 'ERRERRONEUSNICKNAME',  # <NICKNAME> :ERRONEUS NICKNAME
    '433': 'ERRNICKNAMEINUSE',  # <NICKNAME> :NICKNAME IS ALREADY IN USE.
    '436': 'ERRNICKCOLLISION',  # <NICKNAME> :NICKNAME COLLISION KILL
    '437': 'ERRUNAVAILRESOURCE',  # <CHANNEL> :CANNOT CHANGE NICKNAME WHILE BANNED ON CHANNEL
    '438': 'ERRNICKTOOFAST',  # <NICK> :NICK CHANGE TOO FAST. PLEASE WAIT <SEC> SECONDS.
    '439': 'ERRTARGETTOOFAST',  # <TARGET> :TARGET CHANGE TOO FAST. PLEASE WAIT <SEC> SECONDS.
    '441': 'ERRUSERNOTINCHANNEL',  # <NICKNAME> <CHANNEL> :THEY AREN'T ON THAT CHANNEL
    '442': 'ERRNOTONCHANNEL',  # <CHANNEL> :YOU'RE NOT ON THAT CHANNEL
    '443': 'ERRUSERONCHANNEL',  # <NICKNAME> <CHANNEL> :IS ALREADY ON CHANNEL
    '444': 'ERRNOLOGIN',  #
    '445': 'ERRSUMMONDISABLED',  # :SUMMON HAS BEEN DISABLED
    '446': 'ERRUSERSDISABLED',  # :USERS HAS BEEN DISABLED
    '451': 'ERRNOTREGISTERED',  # <COMMAND> :REGISTER FIRST.
    '461': 'ERRNEEDMOREPARAMS',  # <COMMAND> :NOT ENOUGH PARAMETERS
    '462': 'ERRALREADYREGISTERED',  # :YOU MAY NOT REREGISTER
    '463': 'ERRNOPERMFORHOST',  #
    '464': 'ERRPASSWDMISTMATCH',  #
    '465': 'ERRYOUREBANNEDCREEP',  #
    '466': 'ERRYOUWILLBEBANNED',  #
    '467': 'ERRKEYSET',  # <CHANNEL> :CHANNEL KEY ALREADY SET
    '468': 'ERRSERVERCANCHANGE',  # <CHANNEL> :ONLY SERVERS CAN CHANGE THAT MODE
    '471': 'ERRCHANNELISFULL',  # <CHANNEL> :CANNOT JOIN CHANNEL (+L)
    '472': 'ERRUNKNOWNMODE',  # <CHAR> :IS UNKNOWN MODE CHAR TO ME
    '473': 'ERRINVITEONLYCHAN',  # <CHANNEL> :CANNOT JOIN CHANNEL (+I)
    '474': 'ERRBANNEDFROMCHAN',  # <CHANNEL> :CANNOT JOIN CHANNEL (+B)
    '475': 'ERRBADCHANNELKEY',  # <CHANNEL> :CANNOT JOIN CHANNEL (+K)
    '476': 'ERRBADCHANMASK',  #
    '477': 'ERRNICKNOTREGISTERED',  # <CHANNEL> :YOU NEED A REGISTERED NICK TO JOIN THAT CHANNEL.
    '478': 'ERRBANLISTFULL',  # <CHANNEL> <BAN> :CHANNEL BAN/IGNORE LIST IS FULL
    '481': 'ERRNOPRIVILEGES',  # :PERMISSION DENIED- YOU'RE NOT AN IRC OPERATOR
    '482': 'ERRCHANOPRIVSNEEDED',  # <CHANNEL> :YOU'RE NOT CHANNEL OPERATOR
    '483': 'ERRCANTKILLSERVER',  # :YOU CANT KILL A SERVER!
    '484': 'ERRRESTRICTED',  # <NICK> <CHANNEL> :CANNOT KILL, KICK OR DEOP CHANNEL SERVICE
    '485': 'ERRUNIQOPRIVSNEEDED',  # <CHANNEL> :CANNOT JOIN CHANNEL (REASON)
    '491': 'ERRNOOPERHOST',  # :NO O-LINES FOR YOUR HOST
    '501': 'ERRUMODEUNKNOWNFLAG',  # :UNKNOWN MODE FLAG
    '502': 'ERRUSERSDONTMATCH',  # :CANT CHANGE MODE FOR OTHER USERS
    '511': 'ERRSILENCELISTFULL'  # <MASK> :YOUR SILENCE LIST IS FULL
}
